C                                                                       00000200
C          COMPUTER MODELING OF GRAIN GROWTH                            00000300
C          BY MONTE CARLO SIMULATION (gbm.f)
C
C                    New algorithm
C                                                                       00000500
C                      Y.Saito  (1995)      
C                     Waseda University                         
C                                                                       00001400
C-----------------------------------------------------------------------00001500
C          INPUT OF PARAMETERS  (INPUT FILE: DEVICE NO.1 => MTDAT)      00001700
C-----------------------------------------------------------------------00001900
C                                                                       00002000
      parameter (nlat=65536,ngr0=2048)
      common/lat/i0,j0,num
	  common/ran0/idummy
	  common/ran1/ino(nlat),isite(nlat)
	  common/ran2/ngro(0:ngr0)	  
	  common/reo/igrno(nlat)
	  common/reo1/isize(0:ngr0)
	  common/anl0/iside(0:ngr0,0:20)
	  common/anl1/ngtim
	  common/dis/ne(20),nsd(50)
	  dimension eg(20,10),sz(50,10)
	  dimension izeit(10)
	  dimension ixx(6)
	  dimension itr(20)
	  data izeit/10,20,50,100,200,500,1000,2000,5000,10000/
	  OPEN(UNIT=1,FILE="Graingrowth.montecarlo.dat")
      READ(1,300) I0,J0,imcstp,idummy,iq,nogr,aj                    
C                                                                       00002500
C-----------------------------------------------------------------------00002600
C     (I0,J0)  : SIZE OF LATTICE I0 X J0   
C     imcstp   : TOTAL CALCULATION TIME(/MONTE CARLO STEP)
C     idummy   : INITIAL VALUE OF RANDOM NUMBER GENERATOR  
C     iq       : NUMBER OF STATE (GRAIN ORIENTATION)
C     nogr     : Initial number of grains
C     aj       : J/KT                                                   
C                                                                       00003500
C-----------------------------------------------------------------------00003600
C                                                                       00003700
      WRITE(6,1100)                                                     
      WRITE(6,2000) I0,J0,iq,nogr,aj                       
C                                                                       
                                               
      NUM=J0*I0
      TEMP=1.00                                                         
	  t1=aj/temp
C                                                                       00009900
C-----------------------------------------------------------------------00010000
C          INITIAL STATE  Voronoi construction                         
C---------------------------------------------------------------------- 00010400
C
      CALL RANDU(0) 
	  DO 10 I=1,NUM
       IGRNO(I)=0
   10 continue	  
      DO 20 I=1,NOGR                                                  
       IX=ISITE(I) 
	   IF(IGRNO(IX).EQ.0) then
	    call nnb(ix,ixx)
		idf=0
		do 25 j=1,6
		 if(ixx(j).eq.0) ixx(j)=num
		 ixxn=ixx(j)
		 if(igrno(ixxn).eq.0) then
		   igrno(ixxn)=i
		 else
		   idf=1
         endif
   25    continue		 
		 if(idf.eq.0) then
		 	IGRNO(IX)=I
		 else
	       do 27 j=1,6
            if(ixx(j).eq.0) ixx(j)=num
            igrno(ixx(j))=0
   27      continue		   
		 endif  
	   endif
   20 CONTINUE
      do 30 istp=1,50
      call randu(0)
      do 40 i=1,num
	  ix=isite(i)
	  numg=igrno(ix)
	  if(numg.ne.0) then
       call nnb(ix,ixx)
	   do 45 j=1,6
	    ixxx=ixx(j)
		if(ixxx.eq.0) ixxx=num
        if(igrno(ixxx).eq.0) then
	     igrno(ixxx)=numg
	    endif
   45  continue		
      endif
   40 continue
      nla=0
      do 50 i=1,num
	  if(igrno(i).ne.0) then
	   nla=nla+1
	  endif
   50 continue
      write(6,*) istp,nla
	  if(nla.ge.num) go to 31
   30 CONTINUE
   31 continue
      call randu1(iq,nogr)
      call anl(nogr)
c	  
c     transition probability
c
      do 205 i=1,6
	   xit=i
	   trb=2147483647.*exp(-xit*t1)
	   itr(i)=trb
  205 continue
C	  
C    Simulation of grain boundary migration	  
C 
      iplt=1
      do 210 I=1,imcstp
       call randu(iq)
		itry=0
	  do 220 j=1,num
	    ix=isite(j)
	    nng=igrno(ix)
	    ior0=ngro(nng)
        ior1=ino(j)
        call nnb(ix,ixx)
		ini=0
		ire=0
		idf=0
        do 221 jj=1,6
	    if(ixx(jj).eq.0) ixx(jj)=num
	   	 nng0=igrno(ixx(jj))
         ior2=ngro(nng0)
		 if(nng0.ne.nng) then
          ini=ini+1
		 endif
		 if(ior1.eq.ior2) then
		  idf=idf+1
		  nng1=nng0
		 endif
  221   continue
        if(idf.ne.0) then
        do 222 jj=1,6
         if(ixx(jj).eq.0) ixx(jj)=num
	   	 nng0=igrno(ixx(jj))
		 if(nng0.ne.nng1) then
          ire=ire+1
		 endif
  222   continue
		if(ini.ne.0) then
		 itry=itry+1
	     ide=ire-ini
          if(ide.le.0) then 
		   igrno(ix)=nng1
		   isize(nng1)=isize(nng1)+1
		   isize(nng)=isize(nng)-1
		   if(isize(nng).eq.0) ngtim=ngtim-1
		  else
		   call randu2
		    if(idummy.le.itr(ide)) then
		    igrno(ix)=nng1
		    isize(nng1)=isize(nng1)+1
		    isize(nng)=isize(nng)-1
		    if(isize(nng).eq.0) ngtim=ngtim-1
          endif
         endif
		 endif
		 endif
  220 continue
       if((i.lt.50).or.(mod(i,50).eq.0)) then
	      write(6,1700) i,ngtim,itry
		  write(15,1700) i,ngtim
	   endif
	   if(i.eq.izeit(iplt)) then
	     call anl(nogr)
		 do 230 ine=1,20
  230    eg(ine,iplt)=100.*ne(ine)/ngtim
         do 240 isz=1,50
  240    sz(isz,iplt)=100.*nsd(isz)/ngtim
	     iplt=iplt+1
	   endif
  210 continue
       do 250 i=1,20
	   write(6,1800) (eg(i,j),j=1,iplt-1)
	   write(16,1800) (eg(i,j),j=1,iplt-1)
  250 continue
       write(6,1900)
       do 260 i=1,50
	   write(6,1800) (sz(i,j),j=1,iplt-1)
	   write(17,1800) (sz(i,j),j=1,iplt-1)
  260  continue	   
 1000 FORMAT(4i20)  
 1200 FORMAT(11I6)                                                     
 1300 FORMAT(I5)                                                      
 1400 FORMAT(80A1)                                                    
 1500 FORMAT(///' GRAIN BOUNDARY ENERGY MATRIX (MTE) '///)            
 1600 FORMAT(I4,5X,64I1)
 1700 format(4i10)
 1800 format(8f10.2)
 1900 format(//)
 2100 FORMAT(6F10.3)
  300 FORMAT(3I5,I10,2I5,F10.1,I5)                                    
 1100 FORMAT('  SIMULATION OF GRAIN GROWTH BY MONTE CARLO METHOD'
     *///)                                                            
 2000 FORMAT( ' SIZE OF LATTICE (I0,J0) =',2I5/
     *,' NUMBER OF STATE (IQX) =',I5/ 
     *,' INITIAL Number of grains:',I5/                      
     *,' J/KT =',F10.1)  
C                                                                   
      stop                                                           
      END
c
c     nearest neighbour lattice
c
	  subroutine nnb(ix,ixx)
      common/lat/i0,j0,num
	  dimension ixx(6)
      IY0=IX/J0                   
      IF(IY0.EQ.I0) IY0=0        
       IY0=IY0+1               
       IX0=MOD(IX,J0)                                                    
       IXP=IX0+1                                                         
       IYP=IY0+1                                                         
       IXM=IX0-1                                                         
       IYM=IY0-1                                                         
       IF(IXP.GE.J0) IXP=1                                               
       IF(IYP.GT.I0) IYP=1                                               
       IF(IXM.LT.0)  IXM=J0-1                                           
       IF(IYM.LT.1)  IYM=I0                                              
       IYY0=J0*(IY0-1)                                                   
       IYYM=J0*(IYM-1)                                                  
       IYYP=J0*(IYP-1)                                                   
       IXx(1)=IYY0+IXP                                                      
       IXx(2)=IYY0+IXM                                                      
       IXx(3)=IYYM+IXM                                                      
       IXx(4)=IYYM+IX0                                                      
       IXx(5)=IYYP+IX0                                                      
       IXx(6)=IYYP+IXP
	  return
	  end
c	  
c   analysis of grain structure	
c
	  subroutine anl(nogr)
      parameter (nlat=65536,ngr0=2048)
      common/lat/i0,j0,num
	  common/ran2/ngro(0:ngr0)	  
	  common/reo/igrno(nlat)
	  common/reo1/isize(0:ngr0)
	  common/anl0/iside(0:ngr0,0:20)
      common/anl1/ngtim
	  common/dis/ne(20),nsd(50)
	  dimension ixx(6),irn(ngr0)
	  do 90 i=1,20
   90 ne(i)=0	  
	  do 110 i=0,nogr
	  do 120 j=0,20
	  iside(i,j)=0
  120 continue
      isize(i)=0
  110 continue
      write(6,*) nogr,num
      do 130 ix=1,num
       call nnb(ix,ixx)
	   numg=igrno(ix)
	   isize(numg)=isize(numg)+1
	  do 140 i=1,6
	   if(ixx(i).le.0) ixx(i)=num
	   nng0=igrno(ixx(i))
       if(nng0.ne.numg) then
	    ikk=iside(numg,0)
		if(ikk.le.0) then
		 iside(numg,0)=1
		 iside(numg,1)=nng0
		go to 140
		else
		 ichk=0
		 if(ikk.gt.20) ikk=20
      do 150 j=1,ikk
		  if(nng0.ne.iside(numg,j)) then
		   ichk=ichk+1
		  endif
  150 continue
       endif
	   if(ichk.eq.ikk) then
	    ikk1=ikk+1
		if(ikk1.ge.20) ikk1=20
	    iside(numg,0)=ikk1
		iside(numg,ikk1)=nng0
	   endif
      endif
  140 continue
  130 continue
      do 160 i=1,nogr
	  if(isize(i).le.0) go to 160
	  ne(iside(i,0))=ne(iside(i,0))+1
  160 continue
 1000 format(20i4)
C    renumbering of grain 
      irn0=0
      do 170 i=1,nogr
	   if(isize(i).gt.0) then
	    irn0=irn0+1
	    irn(i)=irn0
		ngro(irn(i))=ngro(i)
		isize(irn(i))=isize(i)
	   endif
  170 continue
      do 180 i=1,num
	   inum=igrno(i)
	   igrno(i)=irn(inum)
  180 continue
C     distribution
      avar=num/irn0
	  do 10 i=1,50
   10 nsd(i)=0
      do 195 i=1,irn0
	   rs=isize(i)/avar
	   nrm=rs*10+1
	   if(nrm.gt.50) nrm=50
	   nsd(nrm)=nsd(nrm)+1
  195 continue 
      write(6,*) irn0
	  ngtim=irn0
      return
      end
C                                                                       00062300
C---------------------------------------------------------------------- 00062500
C                                                                       00062600
C          RANDOM NUMBER GENERATOR                                      00062700
C                                                                       00062800
C---------------------------------------------------------------------- 00062900
C                                                                       00063000
      SUBROUTINE RANDU(iq0)
      parameter (nlat=65536)
      common/lat/i0,j0,num
	  common/ran0/idummy
	  common/ran1/ino(nlat),isite(nlat)	
      IY=IDUMMY                                                         
      ANUM=NUM
	  aiq=iq0
	  aq=0.4656612E-9*aiq
      ANM=0.4656612E-9*ANUM 
      DO 10 I=1,NUM 
      IY=IY*65539                                                       
      IF(IY) 15,16,16                                                   
   15 IY=IY+2147483647+1                                               
   16 Y=IY                                                              
      ISITE(I)=Y*ANM+1                                                  
   10 CONTINUE 
	   DO 20 I=1,NUM 
        IY=IY*65539                                                     
        IF(IY) 25,26,26                                                 
   25   IY=IY+2147483647+1         
   26   Y=IY                                                             
        ino(I)=Y*aq+1                                                 
   20  CONTINUE 
 9999 IDUMMY=IY
      RETURN                                                            
      END
	  SUBROUTINE RANDU1(IQ,inn)
      parameter (ngr0=2048)
      common/lat/i0,j0,num
	  common/ran0/idummy
	  common/ran2/nsite(0:ngr0)	  
      IY=IDUMMY                                                         
	  nsite(0)=0
      AQ=IQ                                              
      ANM=0.4656612E-9*AQ
      DO 50 I=1,inn 
      IY=IY*65539                                                       
      IF(IY) 15,16,16                                                   
   15 IY=IY+2147483647+1                                                
   16 Y=IY                                                              
      NSITE(I)=Y*ANM+1 
   50 CONTINUE                                                          
      IDUMMY=IY
      RETURN                                                            
      END
	  SUBROUTINE RANDU2
	  common/ran0/idummy
      IY=IDUMMY                                                         
      IY=IY*65539                                                       
      IF(IY) 15,16,16                                                   
   15 IY=IY+2147483647+1                                                
   16 Y=IY                                                              
      IDUMMY=IY
      RETURN                                                            
      END
